from spawny.main_remotes_and_defs import ScriptDefinition, InstanceDefinition, ModuleDefinition
from spawny.main import ObjectProxy, DaemonProxy, run_script, run_module, run_object, DaemonCouldNotSendMsgError, \
    UnknownException

try:
    # -- Distribution mode: import from _version.py generated by setuptools_scm during release
    from ._version import version as __version__
except ImportError:
    # -- Source mode: use setuptools_scm to get the current version from src using git
    from setuptools_scm import get_version as _gv
    from os import path as _path
    __version__ = _gv(_path.join(_path.dirname(__file__), _path.pardir))

# allow user to do
#    import spawny as a
# and then use a.xxx directly (without the intermediate package name)
__all__ = [
    '__version__',
    # submodules
    'main',
    # symbols
    'run_script', 'run_module', 'run_object',
    'ObjectProxy', 'DaemonProxy', 'InstanceDefinition', 'ScriptDefinition', 'ModuleDefinition',
    'DaemonCouldNotSendMsgError', 'UnknownException'
]
